package ch.hslu.edu.enapp.webshop.boundary;

import java.security.MessageDigest;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.ws.rs.core.MultivaluedMap;

import org.apache.wink.client.Resource;
import org.apache.wink.client.RestClient;
import org.apache.wink.common.internal.MultivaluedMapImpl;

import ch.hslu.edu.enapp.webshop.boundary.dto.Ncresponse;
import ch.hslu.edu.enapp.webshop.common.dto.CustomerDTO;

@Stateless
@LocalBean
public class PaymentService {
	private final String requestURI = "https://e-payment.postfinance.ch/ncol/test/orderdirect.asp";

	private final String PSPID = "HSLUiCompany";
	private final String USERID = "enappstudents";
	private final String PSWD = "Mb%*3Kt9BU";
	private final String CURRENCY = "CHF";

	// Test Mastercard
	// TODO use customer credit card !
	private final String CARDNO = "5399 9999 9999 9999";
	private final String EXPIRY_DATE = "09/15";
	private final String CVC = "789";

	public Ncresponse execPaymentRequest(final String orderId, final double amount, final CustomerDTO customer) {
		final MultivaluedMap<String, String> restData = new MultivaluedMapImpl<String, String>();
		final String amountPostfinance = Long.toString(Math.round(100 * amount));

		String shasign = "";
		final String sig = "hslu!comp@ny.websh0p";
		final StringBuilder sha1sig = new StringBuilder();
		sha1sig.append("AMOUNT=" + amountPostfinance + sig);
		sha1sig.append("CARDNO=" + CARDNO + sig);
		sha1sig.append("CURRENCY=" + CURRENCY + sig);
		sha1sig.append("CVC=" + CVC + sig);
		sha1sig.append("ED=" + EXPIRY_DATE + sig);
		sha1sig.append("ORDERID=" + orderId + sig);
		sha1sig.append("PSPID=" + PSPID + sig);
		sha1sig.append("PSWD=" + PSWD + sig);
		sha1sig.append("USERID=" + USERID + sig);

		try {
			final MessageDigest digest = MessageDigest.getInstance("SHA-1");
			final byte[] hashedBytes = digest.digest(sha1sig.toString().getBytes("UTF-8"));
			shasign = byteArray2HexString(hashedBytes);
			// System.out.println("### SHA1: " + shasign);
		} catch (final Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		restData.add("AMOUNT", amountPostfinance);
		restData.add("CARDNO", CARDNO);
		restData.add("CURRENCY", CURRENCY);
		restData.add("CVC", CVC);
		restData.add("ED", EXPIRY_DATE);
		restData.add("ORDERID", orderId);
		restData.add("PSPID", PSPID);
		restData.add("PSWD", PSWD);
		restData.add("SHASIGN", shasign);
		restData.add("USERID", USERID);

		final RestClient client = new RestClient();
		final Resource webResource = client.resource(requestURI);
		// final ClientResponse response = webResource.contentType("application/x-www-form-urlencoded").post(ClientResponse.class, restData);
		// System.out.println("### RESPONSE: " + response.getEntity(String.class));

		final Ncresponse postfinanceResponse = webResource.contentType("application/x-www-form-urlencoded").post(Ncresponse.class, restData);
		// System.out.println("### OrderId:     " + postfinanceResponse.getOrderID());
		// System.out.println("### PAYID:       " + postfinanceResponse.getPAYID());
		// System.out.println("### NCSTATUS:    " + postfinanceResponse.getNCSTATUS());
		// System.out.println("### NCERROR:     " + postfinanceResponse.getNCERROR());
		// System.out.println("### NCERRORPLUS: " + postfinanceResponse.getNCERRORPLUS());

		return postfinanceResponse;

	}

	private static String byteArray2HexString(final byte[] bytes) {
		final StringBuffer buffer = new StringBuffer();
		for (int i = 0; i < bytes.length; i++) {
			buffer.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
		}
		return buffer.toString();
	}
}
