package ch.hslu.edu.enapp.webshop.control;

import com.ibm.jpa.web.JPAManager;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import com.ibm.jpa.web.NamedQueryTarget;
import com.ibm.jpa.web.Action;
import javax.persistence.PersistenceUnit;
import ch.hslu.edu.enapp.webshop.entity.Authgroup;
import java.util.List;
import javax.persistence.Query;

@SuppressWarnings("unchecked")
@JPAManager(targetEntity = ch.hslu.edu.enapp.webshop.entity.Authgroup.class)
public class AuthgroupManager {

	@PersistenceUnit
	private EntityManagerFactory emf;

	public AuthgroupManager() {
	
	}

	private EntityManager getEntityManager() {
		return emf.createEntityManager();
	}

	@Action(Action.ACTION_TYPE.CREATE)
	public void createAuthgroup(Authgroup authgroup) throws Exception {
		EntityManager em = getEntityManager();
		try {
			em.persist(authgroup);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.DELETE)
	public void deleteAuthgroup(Authgroup authgroup) throws Exception {
		EntityManager em = getEntityManager();
		try {
			authgroup = em.merge(authgroup);
			em.remove(authgroup);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.UPDATE)
	public void updateAuthgroup(Authgroup authgroup) throws Exception {
		EntityManager em = getEntityManager();
		try {
			authgroup = em.merge(authgroup);
		} finally {
			em.close();
		}
	}

	@Action(Action.ACTION_TYPE.FIND)
	public Authgroup findAuthgroupByIdauthgroup(int idauthgroup) {
		Authgroup authgroup = null;
		EntityManager em = getEntityManager();
		try {
			authgroup = (Authgroup) em.find(Authgroup.class, idauthgroup);
		} finally {
			em.close();
		}
		return authgroup;
	}

	@Action(Action.ACTION_TYPE.NEW)
	public Authgroup getNewAuthgroup() {
	
		Authgroup authgroup = new Authgroup();
	
		return authgroup;
	}

	@NamedQueryTarget("getAuthgroupByGroupname")
	public List<Authgroup> getAuthgroupByGroupname(String groupname) {
		EntityManager em = getEntityManager();
		List<Authgroup> results = null;
		try {
			Query query = em.createNamedQuery("getAuthgroupByGroupname");
			query.setParameter("groupname", groupname);
			results = (List<Authgroup>) query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getAuthgroupByIdauthgroup")
	public List<Authgroup> getAuthgroupByIdauthgroup(int idauthgroup) {
		EntityManager em = getEntityManager();
		List<Authgroup> results = null;
		try {
			Query query = em.createNamedQuery("getAuthgroupByIdauthgroup");
			query.setParameter("idauthgroup", idauthgroup);
			results = (List<Authgroup>) query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

	@NamedQueryTarget("getAuthgroup")
	public List<Authgroup> getAuthgroup() {
		EntityManager em = getEntityManager();
		List<Authgroup> results = null;
		try {
			Query query = em.createNamedQuery("getAuthgroup");
			results = (List<Authgroup>) query.getResultList();
		} finally {
			em.close();
		}
		return results;
	}

}