package ch.hslu.edu.enapp.webshop.entity;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * The persistent class for the purchase database table.
 * 
 */
@Entity
@Table(name = "purchase")
@NamedQueries({ @NamedQuery(name = "getPurchaseByNAVOrderId", query = "SELECT p FROM Purchase p WHERE p.NAVOrderId = :NAVOrderId"),
		@NamedQuery(name = "getPurchaseByCorrelationId", query = "SELECT p FROM Purchase p WHERE p.correlationId = :correlationId"),
		@NamedQuery(name = "getPurchaseByStatus", query = "SELECT p FROM Purchase p WHERE p.status = :status"),
		@NamedQuery(name = "getPurchaseByPayid", query = "SELECT p FROM Purchase p WHERE p.payid = :payid"),
		@NamedQuery(name = "getPurchaseByNcstatus", query = "SELECT p FROM Purchase p WHERE p.ncstatus = :ncstatus"),
		@NamedQuery(name = "getPurchaseByNcerrorplus", query = "SELECT p FROM Purchase p WHERE p.ncerrorplus = :ncerrorplus"),
		@NamedQuery(name = "getPurchaseByNcerror", query = "SELECT p FROM Purchase p WHERE p.ncerror = :ncerror"),
		@NamedQuery(name = "getPurchaseByDatetime", query = "SELECT p FROM Purchase p WHERE p.datetime = :datetime"),
		@NamedQuery(name = "getPurchaseByCustomerid", query = "SELECT p FROM Purchase p WHERE p.customerid = :customerid"),
		@NamedQuery(name = "getPurchaseById", query = "SELECT p FROM Purchase p WHERE p.id = :id"),
		@NamedQuery(name = "getPurchase", query = "SELECT p FROM Purchase p") })
public class Purchase implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String correlationId;

	private int customerid;

	@Temporal(TemporalType.TIMESTAMP)
	private Date datetime;

	private String NAVOrderId;

	private int ncerror;

	private String ncerrorplus;

	private int ncstatus;

	private int payid;

	private String status;

	private double totalPrice;

	public Purchase() {
	}

	public int getId() {
		return this.id;
	}

	public void setId(final int id) {
		this.id = id;
	}

	public double getTotalPrice() {
		return this.totalPrice;
	}

	public void setTotalPrice(final double orderAmount) {
		this.totalPrice = orderAmount;
	}

	public String getCorrelationId() {
		return this.correlationId;
	}

	public void setCorrelationId(final String correlationId) {
		this.correlationId = correlationId;
	}

	public int getCustomerid() {
		return this.customerid;
	}

	public void setCustomerid(final int customerid) {
		this.customerid = customerid;
	}

	public Date getDatetime() {
		return this.datetime;
	}

	public void setDatetime(final Date datetime) {
		this.datetime = datetime;
	}

	public String getNAVOrderId() {
		return this.NAVOrderId;
	}

	public void setNAVOrderId(final String NAVOrderId) {
		this.NAVOrderId = NAVOrderId;
	}

	public int getNcerror() {
		return this.ncerror;
	}

	public void setNcerror(final int ncerror) {
		this.ncerror = ncerror;
	}

	public String getNcerrorplus() {
		return this.ncerrorplus;
	}

	public void setNcerrorplus(final String ncerrorplus) {
		this.ncerrorplus = ncerrorplus;
	}

	public int getNcstatus() {
		return this.ncstatus;
	}

	public void setNcstatus(final int ncstatus) {
		this.ncstatus = ncstatus;
	}

	public int getPayid() {
		return this.payid;
	}

	public void setPayid(final int payid) {
		this.payid = payid;
	}

	public String getStatus() {
		return this.status;
	}

	public void setStatus(final String status) {
		this.status = status;
	}

}