package ch.hslu.edu.enapp.webshop.admin.jsf;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import ch.hslu.edu.enapp.webshop.common.CustomerServiceRemote;
import ch.hslu.edu.enapp.webshop.common.dto.AuthgroupDTO;
import ch.hslu.edu.enapp.webshop.common.dto.CustomerDTO;

@Named
@SessionScoped
public class Customer implements Serializable {
	private static final long serialVersionUID = 1L;

	@EJB
	private CustomerServiceRemote customerService;

	@PostConstruct
	public void init() {
		// empty
	}

	public List<CustomerDTO> getCustomer() {
		return customerService.getCustomers();
	}

	public List<AuthgroupDTO> getPermissionGroups(final CustomerDTO customer) {
		return customerService.getPermissionGroups(customer);
	}

	public String getCustomerNameWithLogin(final int customerId) {
		final CustomerDTO customer = customerService.getCustomerById(customerId);
		if (customer.getId() < 1) {
			return "unknow";
		}
		return customer.getName() + " (" + customer.getUsername() + ")";
	}
}
